<template>
  <div class="app-container">
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
        type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['qw:account:add']"
        >添加账号</el-button>
      </el-col>
    </el-row>
    <el-table border v-loading="loading" :data="accountList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="序号"  width="55" type="index" align="center" />
      <el-table-column label="账号id" align="center" prop="id" />
      <el-table-column label="企微账号" align="center" prop="userName" />
      <el-table-column label="姓名" align="center" prop="nickName" />
      <el-table-column label="手机号码" align="center" prop="phone" />
      <el-table-column label="审核状态" align="center" prop="isAudit" >
          <template slot-scope="scope">
              <el-tag prop="isAudit" v-for="(item, index) in isAuditOptions"    v-if="scope.row.isAudit==item.dictValue">{{item.dictLabel}}</el-tag>
          </template>
      </el-table-column>
      <el-table-column width="500" label="关联设备id" align="center" prop="deviceId" />
      <el-table-column label="备注" align="center" prop="remark" />
      
    </el-table>
    
    <!-- <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    /> -->

    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="企微账号" prop="userName">
          <el-input v-model="form.userName" placeholder="请输入企微账号"   />
        </el-form-item>
        <el-form-item label="手机号" prop="phone">
          <el-input v-model="form.phone" placeholder="请输入手机号"   />
        </el-form-item>
        <el-form-item label="姓名" prop="nickName">
          <el-input v-model="form.nickName" placeholder="请输入姓名"   />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark"  type="textarea" :row="5"  />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listAccount, getAccount, delAccount, addAccount, auditAccount, exportAccount } from "@/api/qw/account";
import { getCompanyList } from "@/api/company/company";

export default {
  name: "Account",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      companys:[],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      activeName:"1",
      // 企微功能账号管理表格数据
      accountList: [],
      isAuditOptions:[],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userName: null,
        passWord: null,
        phone: null,
        email: null,
        status: null,
        realName: null,
        nickName: null,
        companyId: null,
        deviceId: null,
        deptId: null,
        companyUserId: null,
        isAudit: 0,
      },
      // 表单参数
      form: {},
      auditForm:{
        id:null,
        isAudit: null,
        deviceId: null,
      },
      // 表单校验
      rules: {
        deviceId: [
          { required: true, message: "关联设备id不能为空", trigger: "blur" }
        ],
        isAudit: [
          { required: true, message: "是否审核不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
    getCompanyList().then(response => {
      this.companys = response.data;
    });
    this.getDicts("common_audit").then((response) => {
      this.isAuditOptions = response.data;
    });
  },
  methods: {
    /** 查询企微功能账号管理列表 */
    getList() {
      this.loading = true;
      listAccount(this.queryParams).then(response => {
        this.accountList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        userName: null,
        passWord: null,
        phone: null,
        email: null,
        createTime: null,

        remark: null,
        realName: null,
        nickName: null,
        companyId: null,
        deviceId: null,
        deptId: null,
        companyUserId: null,
        isAudit: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加企微功能账号管理";
    },
    
    handleAudit(row) {
      this.reset();
      const id = row.id || this.ids
      getAccount(id).then(response => {
        this.form = response.data;
        this.form.companyName = row.companyName;
        this.form.companyUserName = row.companyUserName;
        this.form.isAudit="1"
        this.open = true;
        this.title = "账号审核";
      });
    },
   /** 提交按钮 */
   submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          addAccount(this.form).then(response => {
            if (response.code === 200) {
              this.msgSuccess("审核成功");
              this.open = false;
              this.getList();
            }
          });
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除企微功能账号管理编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delAccount(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有企微功能账号管理数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportAccount(queryParams);
        }).then(response => {
          this.download(response.msg);
        }).catch(function() {});
    }
  }
};
</script>
